unit unSocketReader;

interface
uses Classes,Windows,Messages,IdBaseComponent, IdComponent,
     IdTCPConnection,idStackConsts,IdTCPClient,IdGlobal,sysutils;

Type
   TSocketReaderThread = class(TThread)
       protected
           procedure Execute; override;
       public
           msgHandle : HWND;  //Processing thread
           socket : TIDTcpClient;
           stop : boolean;
   end;

implementation
uses unSMSClient;

procedure TSocketReaderThread.Execute;
var
    cnt : integer;
    inputdata : string;
    p1 : pointer;
Begin
    postMessage(msgHandle,WM_TCP_DATAAVAILABLE,0,0);
    stop := false;
    while (not stop) do begin
      try
         cnt := socket.ReadFromStack(true,IdTimeoutInfinite,true,nil);
         postMessage(msgHandle,WM_TCP_DATAAVAILABLE,cnt,0);
      except
         postMessage(msgHandle,WM_TCP_SOCKET_DISCONNECTED,0,0);
         stop := true;
      end;
    end;
End;

end.
